"use client";

import React, { useEffect, useState } from 'react';
import { useSDK } from '@metamask/sdk-react';
import { Typography, Box, Grid } from '@mui/material';
import Web3 from 'web3';

const WalletInfo = () => {
    const { sdk, connected } = useSDK();
    const [account, setAccount] = useState(null);
    const [balance, setBalance] = useState(null);

    useEffect(() => {
        const fetchWalletInfo = async () => {
            try {
                const web3 = new Web3(window.ethereum);
                const accounts = await web3.eth.getAccounts();
                console.log("accounts", accounts[0]);
                setAccount(accounts?.[0]);

                const balanceEth = await web3.eth.getBalance(accounts[0]);
                console.log("Balance in ETH:", balanceEth);

                const balanceWei = web3.utils.toWei(balanceEth, 'ether');
                console.log("Balance in WEI:", balanceWei);

                setBalance(balanceWei);

            } catch (error) {
                console.error('Error fetching wallet information:', error);
            }
        };

        fetchWalletInfo();
    }, []);

    return (
        <Grid item xs={12} textAlign="center">
            <Typography variant="h4" color="primary">Info sur le portefeuille</Typography>
            <Typography variant="h6">Adresse du portefeuille :</Typography>
            <Typography variant="body1">{account}</Typography>
            <Typography variant="h6">Solde en ETH :</Typography>
            <Typography variant="body1">{balance} ETH</Typography>
        </Grid>
    );
};

export default WalletInfo;
